﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;
using System.Windows.Media.Imaging;

namespace Services_Demo
{
    public partial class CameraCaptureTaskPage : PhoneApplicationPage
    {   
        // Declare CameraCaptureTask in page scope
        CameraCaptureTask cameraCaptureTask;

        public CameraCaptureTaskPage()
        {
            InitializeComponent();      
            
            // Initialize CameraCaptureTask 
            cameraCaptureTask = new CameraCaptureTask();

            // Attach Completed handler
            cameraCaptureTask.Completed += new EventHandler<PhotoResult>(CameraCaptureTask_Completed);
        }

        private void Choose_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                cameraCaptureTask.Show();
            }
            catch (System.InvalidOperationException ex)
            {
                // Catch the exception in case of a "double tap"
            }
        }

        // Completed event handler
        void CameraCaptureTask_Completed(object sender, PhotoResult e)
        {
            if (e.TaskResult == TaskResult.OK)
            {
                BitmapImage image = new BitmapImage();
                image.SetSource(e.ChosenPhoto);
                CapturedImage.Source = image;
            }
            else
            {
                MessageBox.Show(String.Format("Task returned with {0} result.", e.TaskResult.ToString()));
                CapturedImage.Source = null;
            }
        }
    }
}