﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;

namespace Services_Demo
{
    public partial class EmailAddressChooserTaskPage : PhoneApplicationPage
    {
        // Declare EmailAddressChooserTask  in the page scope
        EmailAddressChooserTask emailAddressChooserTask;

        public EmailAddressChooserTaskPage()
        {
            InitializeComponent();

            // Initialize the EmailAddressChooserTask 
            emailAddressChooserTask = new EmailAddressChooserTask();
            
            // Attach Completed handler
            emailAddressChooserTask.Completed += new EventHandler<EmailResult>(emailAddressChooserTask_Completed);
        }

        private void Choose_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                emailAddressChooserTask.Show();
            }
            catch (System.InvalidOperationException ex)
            {
                // Catch the exception in case of a "double tap"
            }
        }

        // Completed event handler
        void emailAddressChooserTask_Completed(object sender, EmailResult e)
        {
            if (e.TaskResult == TaskResult.OK)
            {
                MessageBox.Show(String.Format("Selected email is: {0}", e.Email));
            }
            else
            {
                MessageBox.Show(String.Format("Task returned with {0} result.", e.TaskResult.ToString()));
            }
        }

    }
}