﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Devices.Radio;

namespace Services_Demo
{
    public partial class MainPage : PhoneApplicationPage
    {
        FMRadio radio = FMRadio.Instance;

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            // Set the data context of the listbox control to the sample data
            DataContext = App.ViewModel;
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        // Load data for the ViewModel Items
        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            if (!App.ViewModel.IsDataLoaded)
            {
                App.ViewModel.LoadData();
            }

            // Check if radio is on
            if (radio.PowerMode == RadioPowerMode.On)
            {
                FMFrequency.Text = radio.Frequency.ToString();
            }
            else
            {
                FMFrequency.Text = "000.0";
            }
        }

        #region Radio Functionality
        
        private void offButton_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                radio.PowerMode = RadioPowerMode.Off;
                FMFrequency.Text = "000.0";
            }
            catch (Exception)
            {
                // Means the headphones were not plugged in anyways
            }
        }

        private void onButton_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                radio.PowerMode = RadioPowerMode.On;
                FMFrequency.Text = radio.Frequency.ToString();                
            }
            catch (Exception)
            {
                MessageBox.Show("Are your headphones plugged in?");
            }
        }

        private void nextButton_Click(object sender, RoutedEventArgs e)
        {
            radio.Frequency = radio.Frequency + 0.1;
            FMFrequency.Text = radio.Frequency.ToString();
        }

        private void prevButton_Click(object sender, RoutedEventArgs e)
        {
            radio.Frequency = radio.Frequency - 0.1;
            FMFrequency.Text = radio.Frequency.ToString();
        }

        #endregion

        #region Navigation 

        private void LauchersListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ItemViewModel selectedItem = LauchersListBox.SelectedItem as ItemViewModel;

            this.NavigationService.Navigate(new Uri(String.Format("//{0}Page.xaml", selectedItem.TaskName), UriKind.Relative));
        }

        private void ChoosersListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ItemViewModel selectedItem = ChoosersListBox.SelectedItem as ItemViewModel;

            this.NavigationService.Navigate(new Uri(String.Format("/{0}Page.xaml", selectedItem.TaskName), UriKind.Relative));
        }

        #endregion
    }
}