﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;

namespace Services_Demo
{
    public partial class PhoneNumberChooserTaskPage : PhoneApplicationPage
    {    
        // Declare PhoneNumberChooserTask in page scope
        PhoneNumberChooserTask phoneNumberChooserTask;


        public PhoneNumberChooserTaskPage()
        {
            InitializeComponent();        
            
            // Initialize PhoneNumberChooserTask 
            phoneNumberChooserTask = new PhoneNumberChooserTask();

            // Attach Completed handler 
            phoneNumberChooserTask.Completed += new EventHandler<PhoneNumberResult>(phoneNumberChooserTask_Completed);

        }

        private void Choose_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                phoneNumberChooserTask.Show();
            }
            catch (System.InvalidOperationException ex)
            {
                // Catch the exception, but no handling is necessary.
            }
        }

        // Completed event handler
        void phoneNumberChooserTask_Completed(object sender, PhoneNumberResult e)
        {
            if (e.TaskResult == TaskResult.OK)
            {
                MessageBox.Show(String.Format("Selected phone # is: {0}", e.PhoneNumber));
            }
            else
            {
                MessageBox.Show(String.Format("Task returned with {0} result.", e.TaskResult.ToString()));
            }
        }
    }
}