﻿using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace Services_Demo
{
    public class ItemViewModel : INotifyPropertyChanged
    {
        private string _taskName;
        /// <summary>
        /// Name of the Task.
        /// </summary>
        /// <returns></returns>
        public string TaskName
        {
            get
            {
                return _taskName;
            }
            set
            {
                if (value != _taskName)
                {
                    _taskName = value;
                    NotifyPropertyChanged("TaskName");
                }
            }
        }

        private string _taskDescription;
        /// <summary>
        /// Description
        /// </summary>
        /// <returns></returns>
        public string TaskDescription
        {
            get
            {
                return _taskDescription;
            }
            set
            {
                if (value != _taskDescription)
                {
                    _taskDescription = value;
                    NotifyPropertyChanged("TaskDescription");
                }
            }
        }

        private bool _launcher;
        /// <summary>
        /// Is this a Launcher? If not - chooser
        /// </summary>
        /// <returns></returns>
        public bool Launcher
        {
            get
            {
                return _launcher;
            }
            set
            {
                if (value != _launcher)
                {
                    _launcher = value;
                    NotifyPropertyChanged("Launcher");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (null != handler)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}