﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Collections.ObjectModel;


namespace Services_Demo
{
    public class MainViewModel : INotifyPropertyChanged
    {
        public MainViewModel()
        {
            this.Launchers = new ObservableCollection<ItemViewModel>();
            this.Choosers = new ObservableCollection<ItemViewModel>();
        }

        /// <summary>
        /// A collection for ItemViewModel objects.
        /// </summary>
        public ObservableCollection<ItemViewModel> Launchers { get; private set; }

        /// <summary>
        /// A collection for ItemViewModel objects.
        /// </summary>
        public ObservableCollection<ItemViewModel> Choosers { get; private set; }

        //private string _sampleProperty = "Sample Runtime Property Value";
        ///// <summary>
        ///// Sample ViewModel property; this property is used in the view to display its value using a Binding
        ///// </summary>
        ///// <returns></returns>
        //public string SampleProperty
        //{
        //    get
        //    {
        //        return _sampleProperty;
        //    }
        //    set
        //    {
        //        if (value != _sampleProperty)
        //        {
        //            _sampleProperty = value;
        //            NotifyPropertyChanged("SampleProperty");
        //        }
        //    }
        //}

        public bool IsDataLoaded
        {
            get;
            private set;
        }

        /// <summary>
        /// Creates and adds a few ItemViewModel objects into the Items collection.
        /// </summary>
        public void LoadData()
        {
            // Launchers
            this.Launchers.Add(new ItemViewModel() { Launcher = true, TaskName = "EmailComposeTask" });
            this.Launchers.Add(new ItemViewModel() { Launcher = true, TaskName = "MarketplaceDetailTask" });
            this.Launchers.Add(new ItemViewModel() { Launcher = true, TaskName = "MarketplaceHubTask" });
            this.Launchers.Add(new ItemViewModel() { Launcher = true, TaskName = "MarketplaceSearchTask" });
            this.Launchers.Add(new ItemViewModel() { Launcher = true, TaskName = "MarketplaceReviewTask" });
            this.Launchers.Add(new ItemViewModel() { Launcher = true, TaskName = "MediaPlayerLauncher" });
            this.Launchers.Add(new ItemViewModel() { Launcher = true, TaskName = "PhoneCallTask" });
            this.Launchers.Add(new ItemViewModel() { Launcher = true, TaskName = "SearchTask" });
            this.Launchers.Add(new ItemViewModel() { Launcher = true, TaskName = "SmsComposeTask" });
            this.Launchers.Add(new ItemViewModel() { Launcher = true, TaskName = "WebBrowserTask" });
            
            // Choosers
            this.Choosers.Add(new ItemViewModel() { Launcher = false, TaskName = "CameraCaptureTask" });
            this.Choosers.Add(new ItemViewModel() { Launcher = false, TaskName = "PhotoChooserTask" });
            this.Choosers.Add(new ItemViewModel() { Launcher = false, TaskName = "SaveEmailAddressTask" });
            this.Choosers.Add(new ItemViewModel() { Launcher = false, TaskName = "EmailAddressChooserTask" });            
            this.Choosers.Add(new ItemViewModel() { Launcher = false, TaskName = "SavePhoneNumberTask" });
            this.Choosers.Add(new ItemViewModel() { Launcher = false, TaskName = "PhoneNumberChooserTask" });

            this.IsDataLoaded = true;
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (null != handler)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}