﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace BindingExamples
{
public class Author : INotifyPropertyChanged
{
    public Author()
    {
        // default values
        FullName = "Joe Healy";
        City = "St Petersburg";
        State = "Florida";
        NonBindableText = "you should not see this in a bind";
    }

    // not bindable as it doesn't use properties but fields
    public String NonBindableText;

    private string m_FullName;
    public String FullName 
    {
        get { return m_FullName; }
        set
        {
            m_FullName = value;
            NotifyPropertyChanged("FullName");
        }
    }

        private string m_City;
        public String City 
        {
            get { return m_City; }
            set
            {
                m_City = value;
                NotifyPropertyChanged("City");
            }
        }

        private string m_State;
        public String State 
        {
            get { return m_State; }
            set
            {
                m_State = value;
                NotifyPropertyChanged("State");
            }
        }

public event PropertyChangedEventHandler PropertyChanged;
public void NotifyPropertyChanged(string propertyName)
{
    if (PropertyChanged != null)
    {
        PropertyChanged(this,
            new PropertyChangedEventArgs(propertyName));
    }
}
    }
}

    //// Create the property that will be the source of the binding.
    //public SolidColorBrush Brush1
    //{
    //    get { return _Brush1; }
    //    set
    //    {
    //        _Brush1 = value;
    //        // Call NotifyPropertyChanged when the source property 
    //        // is updated.
    //        NotifyPropertyChanged("Brush1");
    //    }
    //}

