﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace ConsumingServicesClient
{
    // progress notifications
    // cancel option
    public partial class WebClientPageExtended : PhoneApplicationPage
    {
        private WebClient m_myWebClient = new WebClient();
        public WebClientPageExtended()
        {
            InitializeComponent();
            m_myWebClient = new WebClient();
            m_myWebClient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(myWebClient_DownloadStringCompleted);
            m_myWebClient.DownloadProgressChanged += new DownloadProgressChangedEventHandler(m_myWebClient_DownloadProgressChanged);

            this.Loaded += new RoutedEventHandler(WebClientPageExtended_Loaded);
        }

        void WebClientPageExtended_Loaded(object sender, RoutedEventArgs e)
        {
            InitResults();
        }

        void m_myWebClient_DownloadProgressChanged(object sender, DownloadProgressChangedEventArgs e)
        {
            long _bytesReceived = e.BytesReceived;
            int _progress = e.ProgressPercentage;
            long _totalBytes = e.TotalBytesToReceive;
            UpdateResults(String.Format("DownloadProgressChanged: bytes:{0},progress: {1},totalbytes: {2}", _bytesReceived.ToString(), _progress.ToString(), _totalBytes.ToString()));
        }

        void myWebClient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            UpdateResults("DownloadStringCompleted");
            // if webclient call was cancelled this event is raised but trying to query e.result raises an exception
            // here we trap and deal with it
            try
            {
                UpdateResults(e.Result);
            }
            catch (Exception ex)
            {
                UpdateResults("download results unavailable");
                UpdateResults(ex.ToString());
            }
        }

        private void UpdateResults(string s)
        {
            textBlockResults.Text = String.Concat(textBlockResults.Text, Environment.NewLine, s);
        }

        private void buttonCall_Click(object sender, RoutedEventArgs e)
        {
            InitResults();
            string targetURI = Application.Current.Resources["TargetWebURI"].ToString();
            m_myWebClient.DownloadStringAsync(new System.Uri(targetURI));
        }

        private void buttonCancel_Click(object sender, RoutedEventArgs e)
        {
            m_myWebClient.CancelAsync();
            UpdateResults("call cancelled");
        }
        
        private bool HazNetwork()
        {
            return ! ( Microsoft.Phone.Net.NetworkInformation.NetworkInterface.NetworkInterfaceType == Microsoft.Phone.Net.NetworkInformation.NetworkInterfaceType.None  );
        }
        private void InitResults()
        {
            textBlockResults.Text = string.Empty;
            UpdateResults("HazNetwork=" + HazNetwork().ToString());
        }
    }
}