﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using System.Data.Services.Client;

using INETALivePublicModel;

namespace ConsumingServicesClient
{
    public partial class INETAPage : PhoneApplicationPage
    {
        private DataServiceContext m_INETAContext;
        private readonly Uri m_INETAUri = new Uri("http://live.ineta.org/InetaLiveService.svc/");
        private DataServiceCollection<LivePresentation> m_PresentationsCollection;
        private readonly Uri m_customersFeedUri = new Uri("/LivePresentations", UriKind.Relative);

        public INETAPage()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(NWindPage_Loaded);
        }

        void NWindPage_Loaded(object sender, RoutedEventArgs e)
        {
            m_INETAContext = new DataServiceContext(m_INETAUri);
            m_PresentationsCollection = new DataServiceCollection<LivePresentation>(m_INETAContext);
            m_PresentationsCollection.LoadCompleted += new EventHandler<LoadCompletedEventArgs>(customers_LoadCompleted);
            m_PresentationsCollection.LoadAsync(m_customersFeedUri);
        }

        void customers_LoadCompleted(object sender, LoadCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                if (m_PresentationsCollection.Continuation != null)
                {
                    m_PresentationsCollection.LoadNextPartialSetAsync();
                }
                else
                {
                    listBoxContent.ItemsSource = from _p in m_PresentationsCollection orderby _p.DeliveredOn descending select _p;
                }
            }
            else
            {
                MessageBox.Show("woops = " + e.Error.Message);
            }
        }
    }
}