﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Xml;
using System.IO;
using System.ServiceModel.Syndication;

namespace SyndicationFeedSample
{
    public partial class MainPage : PhoneApplicationPage
    {
        private WebClient webClient;

        // Constructor
        public MainPage()
        {
            InitializeComponent();
            this.webClient = new WebClient();
            this.webClient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(webClient_DownloadStringCompleted);
        }

        void webClient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if (!String.IsNullOrEmpty(e.Result)) 
            { 
                using (StringReader reader = new StringReader(e.Result)) 
                { 
                    using (XmlReader xmlReader = XmlReader.Create(reader)) 
                    { 
                        SyndicationFeed feed = SyndicationFeed.Load(xmlReader); 
                        this.listBoxChannelInfo.Items.Add(feed.Title.Text); 
                        this.listBoxChannelInfo.Items.Add (feed.Authors.FirstOrDefault().Name); 
                        this.listBoxChannelInfo.Items.Add("updated " + feed.LastUpdatedTime.ToString()); 
                        this.listBoxContent.ItemsSource = feed.Items; 
                    } 
                } 
            } 
        }

        private void buttonGetFeed_Click(object sender, RoutedEventArgs e)
        {
            webClient.DownloadStringAsync(new Uri(this.textBlockFeed.Text));
        }
    }
}