﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

// photos extras stuff
using Microsoft.Phone;
using Microsoft.Xna.Framework.Media;
using System.IO;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;

namespace SAMSPhotoExtras
{
    public partial class MainPage : PhoneApplicationPage
    {
        WriteableBitmap m_picLibImage;

        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            IDictionary<string, string> querystrings = this.NavigationContext.QueryString;
            if (querystrings.ContainsKey("token"))
            {
                MediaLibrary lib = new MediaLibrary();

                // get pic from local media db using passed token
                Picture pic = lib.GetPictureFromToken(querystrings["token"]);
                
                // create writable bitmap and stuff into image
                BitmapImage bmp = new BitmapImage();
                bmp.SetSource(pic.GetImage());
                m_picLibImage  = new WriteableBitmap(bmp);

                // neonize the image just for the heckuvit
                for (int curpix = 0; curpix < m_picLibImage.Pixels.Length; curpix++)
                {
                    m_picLibImage.Pixels[curpix] = m_picLibImage.Pixels[curpix] + 100;
                }
                retrievePic.Source = m_picLibImage;
            }
        }

        private void buttonSave_Click(object sender, RoutedEventArgs e)
        {
            string debugplace = "start";
            try
            {
                const string tempjpg = "temp.jpg";
                System.IO.IsolatedStorage.IsolatedStorageFile myStore = System.IO.IsolatedStorage.IsolatedStorageFile.GetUserStoreForApplication();

                // temporarily save file out to our store
                if (myStore.FileExists(tempjpg))
                {
                    myStore.DeleteFile(tempjpg);
                }
                debugplace = "creating temp file";
                

                using (System.IO.IsolatedStorage.IsolatedStorageFileStream fs = myStore.CreateFile(tempjpg))
                {
                    // dumps it to our file store
                    m_picLibImage.SaveJpeg(fs, m_picLibImage.PixelWidth, m_picLibImage.PixelHeight, 0, 85);
                }
                debugplace = "opening temp file";
                using (System.IO.IsolatedStorage.IsolatedStorageFileStream fs = myStore.OpenFile(tempjpg, FileMode.Open, FileAccess.Read))
                {
                    MediaLibrary lib = new MediaLibrary();
                    debugplace = "savingpicture";
                    Picture pic = lib.SavePicture(textBoxSaveName.Text + ".jpg", fs);
                    debugplace = "done";
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(debugplace);
                //MessageBox.Show(ex.ToString(), debugplace + "!", MessageBoxButton.OK);
                System.Diagnostics.Debug.WriteLine(ex.ToString());
            }
        }
    }
}