﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace SAMSVideoPlayer
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
            media.MediaOpened += new RoutedEventHandler(media_MediaOpened);
            media.MediaFailed += new EventHandler<ExceptionRoutedEventArgs>(media_MediaFailed);
            media.CurrentStateChanged += new RoutedEventHandler(media_CurrentStateChanged);
        }

        void media_MediaFailed(object sender, ExceptionRoutedEventArgs e)
        {
            MessageBox.Show(e.ErrorException.ToString(), "MediaFailed", MessageBoxButton.OK);
        }

        void media_MediaOpened(object sender, RoutedEventArgs e)
        {
            textBlockDuration.Text = media.NaturalDuration.ToString();
        }

        void media_CurrentStateChanged(object sender, RoutedEventArgs e)
        {
            textBlockStatus.Text = media.CurrentState.ToString();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if (sender is Button)
            {
                Button button = (Button)sender;
                media.Stop();
                media.Source = new Uri(@"/videos/" + button.Content, UriKind.Relative);
                media.Play();
            }
        }

        private void buttonStart_Click(object sender, RoutedEventArgs e)
        {
            if ((media.CurrentState == MediaElementState.Stopped) || (media.CurrentState == MediaElementState.Paused) || (media.CurrentState == MediaElementState.Opening ) )
            {
                media.Play();
            }
        }

        private void buttonStop_Click(object sender, RoutedEventArgs e)
        {
            if (media.CurrentState == MediaElementState.Playing)
            {
                media.Pause();
            }
        }
    }
}