﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

//#nowplaying
using Microsoft.Devices;
using System.Windows.Resources;

namespace SAMSVideoPlayer
{
    public partial class MainPage : PhoneApplicationPage
    {
        // vars for  "history" or "new" launch
        bool m_HistoryItemLaunched = false;
        const string m_VideoKey = "SAMSVideoKey";
        private string m_VideoToPlay = string.Empty;
        
        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            // we were launched from a history item
            if (NavigationContext.QueryString.ContainsKey(m_VideoKey))
            {
                // find which video
                m_VideoToPlay = NavigationContext.QueryString[m_VideoKey];
                m_HistoryItemLaunched = true;
            }
        }


        // Constructor
        public MainPage()
        {
            InitializeComponent();
            media.MediaFailed += new EventHandler<ExceptionRoutedEventArgs>(media_MediaFailed);
            media.MediaOpened += new RoutedEventHandler(media_MediaOpened);
            media.CurrentStateChanged += new RoutedEventHandler(media_CurrentStateChanged);

            this.Loaded +=new RoutedEventHandler( PhoneApplicationPage_Loaded );
        }
        
        void media_MediaFailed(object sender, ExceptionRoutedEventArgs e)
        {
            MessageBox.Show(e.ErrorException.ToString(), "UpdateNowPlaying", MessageBoxButton.OK);
        }

        void media_MediaOpened(object sender, RoutedEventArgs e)
        {
            textBlockDuration.Text = media.NaturalDuration.ToString();
            UpdateNowPlaying();
            UpdateHistoryList();
            UpdateNewList(); //doesnt make much sense but done here as an exercise
        }

private void UpdateNewList()
{
    try
    {
        MediaHistoryItem myMediaHistoryItem = new MediaHistoryItem();
        Uri imageUri = new Uri(@"images/VideoPlayer173.jpg", UriKind.Relative);
        StreamResourceInfo sri = Application.GetResourceStream(imageUri);
        myMediaHistoryItem.ImageStream = sri.Stream;
        myMediaHistoryItem.Source = "";
        myMediaHistoryItem.Title = "SAMSVideoPlayer New Content";
        myMediaHistoryItem.PlayerContext.Add(media.Source.ToString(), media.Source.ToString());
        MediaHistory.Instance.WriteAcquiredItem(myMediaHistoryItem);
    }
    catch (Exception ex)
    {
        MessageBox.Show(ex.ToString(), "UpdateNowPlaying", MessageBoxButton.OK);
    }
}

private void UpdateNowPlaying()
{
    try
    {
        MediaHistoryItem myMediaHistoryItem = new MediaHistoryItem();
        Uri imageUri = new Uri(@"images/VideoPlayer358.jpg", UriKind.Relative);
        StreamResourceInfo sri = Application.GetResourceStream(imageUri);
        myMediaHistoryItem.ImageStream = sri.Stream;
        myMediaHistoryItem.Source = "";
        myMediaHistoryItem.Title = media.Source.ToString();
        myMediaHistoryItem.PlayerContext.Add(m_VideoKey, media.Source.ToString());
        MediaHistory.Instance.NowPlaying = myMediaHistoryItem;
    }
    catch (Exception ex)
    {
        MessageBox.Show(ex.ToString(), "UpdateNowPlaying", MessageBoxButton.OK);
    }            
}

private void UpdateHistoryList()
{
    try
    {
        MediaHistoryItem myMediaHistoryItem = new MediaHistoryItem();
        Uri imageUri = new Uri(@"images/VideoPlayer173.jpg", UriKind.Relative);
        StreamResourceInfo sri = Application.GetResourceStream(imageUri);
        myMediaHistoryItem.ImageStream = sri.Stream;
        myMediaHistoryItem.Source = "";
        myMediaHistoryItem.Title = "SAMSVideoPlayer";
        myMediaHistoryItem.PlayerContext.Add(media.Source.ToString(), media.Source.ToString());
        MediaHistory.Instance.WriteRecentPlay(myMediaHistoryItem);
    }
    catch (Exception ex)
    {
        MessageBox.Show(ex.ToString(), "UpdateNowPlaying", MessageBoxButton.OK);
    }
}

        void media_CurrentStateChanged(object sender, RoutedEventArgs e)
        {
            textBlockStatus.Text = media.CurrentState.ToString();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if (sender is Button)
            {
                Button button = (Button)sender;
                media.Stop();
                media.Source = new Uri(@"videos/" + button.Content, UriKind.Relative);
                media.Play();
            }
        }

        private void buttonStart_Click(object sender, RoutedEventArgs e)
        {
            if ((media.CurrentState == MediaElementState.Stopped) || (media.CurrentState == MediaElementState.Paused) || (media.CurrentState == MediaElementState.Opening ) )
            {
                media.Play();
            }
        }

        private void buttonStop_Click(object sender, RoutedEventArgs e)
        {
            if (media.CurrentState == MediaElementState.Playing)
            {
                media.Pause();
            }
        }

        // history
        private void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            // if history launched then set media source
            if (m_HistoryItemLaunched)
            {
                media.Source = new Uri(m_VideoToPlay, UriKind.Relative);
                media.Play();
            }
        }
    }
}