﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

namespace BingSearchSDK
{
    public partial class JSONWebReqPage : PhoneApplicationPage
    {
        private WebClient m_WebClient = new WebClient();
        string m_AppId;

        public JSONWebReqPage()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(JSONWebReqPage_Loaded);
        }

        void JSONWebReqPage_Loaded(object sender, RoutedEventArgs e)
        {
            m_WebClient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(m_WebClient_DownloadStringCompleted);
            m_AppId = Application.Current.Resources["AppId"] as String;
        }

        void m_WebClient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            textBlockOut.Text = e.Result.ToString();
            System.Diagnostics.Debug.WriteLine(e.Result.ToString());
        }

        void DoSearch()
        {
            string requestStr = "http://api.bing.net/json.aspx?"

                // Common request fields (required)
                + "AppId=" + m_AppId
                + "&Query=" + textBoxSearch.Text
                + "&Sources=Web"

                // Common request fields (optional)
                //+ "&Version=2.0"
                + "&Market=en-us"
                //+ "&Adult=Moderate"
                //+ "&Options=EnableHighlighting"

                // Web-specific request fields (optional)
                //+ "&Web.Count=10"
                //+ "&Web.Offset=0"
                //+ "&Web.Options=DisableHostCollapsing+DisableQueryAlterations"

                // JSON-specific request fields (optional)
                + "&JsonType=callback"
                + "&JsonCallback=SearchCompleted";
            System.Diagnostics.Debug.WriteLine(requestStr);
            m_WebClient.DownloadStringAsync(new Uri(requestStr), null);
        }

        private void buttonSearch_Click(object sender, RoutedEventArgs e)
        {
            DoSearch();
        }
    }
}