﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

// step1
using System.Xml;
using System.IO;

using System.Threading;

namespace RawXMLResultPage
{
    public partial class MainPage : PhoneApplicationPage
    {
        OutMsg m_Out;
        String m_AppId = string.Empty;

        // Constructor
        public MainPage()
        {
            InitializeComponent();
            m_Out = new OutMsg(textBlockOut);
            m_AppId = Application.Current.Resources["AppId"] as String;
        }

        private void buttonSearch_Click(object sender, RoutedEventArgs e)
        {
            m_Out.Clear();
            m_Out.WriteLine("XML API");
            HttpWebRequest req = BuildXMLRequest();
            try
            {
                req.BeginGetResponse(new AsyncCallback(ReadWebRequestCallback), req);
            }
            catch (Exception ex)
            {
                m_Out.WriteLine(ex.ToString());
            }
        } // search

        private HttpWebRequest BuildXMLRequest()
        {
            string requestString = "http://api.bing.net/xml.aspx?"

                // Common request fields (required)
                + "AppId=" + m_AppId
                + "&Query=" + textBoxSearch.Text
                + "&Sources=Web"

                // Common request fields (optional)
                + "&Market=en-us";

            // Create and initialize the request.
            HttpWebRequest request = (HttpWebRequest)HttpWebRequest.Create(
                requestString);

            System.Diagnostics.Debug.WriteLine(requestString);

            return request;
        }

        private void ReadWebRequestCallback(IAsyncResult callbackResult )
        {
            HttpWebRequest myRequest = (HttpWebRequest)callbackResult.AsyncState;
            HttpWebResponse myResponse = (HttpWebResponse)myRequest.EndGetResponse(callbackResult);

            using (StreamReader httpwebStreamReader = new StreamReader(myResponse.GetResponseStream()))
            {
                string results = httpwebStreamReader.ReadToEnd();
                Dispatcher.BeginInvoke(()=> m_Out.WriteLine( results ));
                // DisplayResponse(response);
            }
        }

    }

}