﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Windows.Controls;
using System.Windows.Threading;
using System.IO.IsolatedStorage;


    public class OutMsg
    {
        private TextBlock MyTextBlock { get; set; }

        public OutMsg()
        {
            MyTextBlock = null;
        }

        public OutMsg(TextBlock txt)
        {
            if (txt != null) MyTextBlock = txt;
        }


        public void Clear()
        {
            if ( MyTextBlock!=null) MyTextBlock.Text = String.Empty;
        }

        public void DateStamp()
        {
            this.WriteLine(System.DateTime.Now.ToString());
        }

        public void InspectFile(string filename)
        {
            IsolatedStorageFile store = IsolatedStorageFile.GetUserStoreForApplication();
            this.WriteLine("--- begin inspecting " + filename);
            this.WriteLine("exists?: " + store.FileExists(filename));
            using (IsolatedStorageFileStream stream = store.OpenFile(filename, System.IO.FileMode.Open))
            {
                this.WriteLine("length: " + stream.Length);
            }
            this.WriteLine("--- begin inspecting " + filename);
        }

        public void WriteLine(Exception ex)
        {
            WriteLine("exception", ex.ToString());
        }

        public void WriteLine(string s)
        {
            System.Diagnostics.Debug.WriteLine(s);            
            if (MyTextBlock != null)
            {
                MyTextBlock.Text =  String.Format("{0}{1}{2}", MyTextBlock.Text, Environment.NewLine, s);
            }
        }

        public void WriteLine(string cat, string msg)
        {
            this.WriteLine(String.Format("{0}: {1}", cat, msg));
        }

        public void NewLine()
        {
            System.Diagnostics.Debug.WriteLine("");
            if (MyTextBlock != null)
            {
                MyTextBlock.Text = String.Format("{0}{1}", MyTextBlock.Text, Environment.NewLine);
            }
        }
    }
