﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Globalization;

namespace CH20_Culture
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
            PopulateGrid();
        }

        private void PopulateGrid()
        {  
            CultureInfo current = System.Threading.Thread.CurrentThread.CurrentCulture;
            CultureInfo spanish = new CultureInfo("es-ES");

            long amount = 123456789;
            
            var items = new List<CultureInfoData>()
            { 
                new CultureInfoData("SETTING", "CURRENT", "SPANISH"),
                new CultureInfoData("EnglishName", current.EnglishName,spanish.EnglishName),
                new CultureInfoData("Calendar", current.Calendar.ToString(),spanish.Calendar.ToString()),
                new CultureInfoData("ShortDateFormat",current.DateTimeFormat.ShortDatePattern.ToString(),spanish.DateTimeFormat.ShortDatePattern.ToString()),
                new CultureInfoData("ShortDate Sample",DateTime.Now.ToString(current.DateTimeFormat.ShortDatePattern),DateTime.Now.ToString(spanish.DateTimeFormat.ShortDatePattern)),
                new CultureInfoData("LongDateFormat",current.DateTimeFormat.LongDatePattern.ToString(),spanish.DateTimeFormat.LongDatePattern.ToString()),
                new CultureInfoData("LongDate Sample",DateTime.Now.ToString(current.DateTimeFormat.LongDatePattern),DateTime.Now.ToString(spanish.DateTimeFormat.LongDatePattern)),
                new CultureInfoData("Currency Symbol",current.NumberFormat.CurrencySymbol,spanish.NumberFormat.CurrencySymbol),
                new CultureInfoData("Currency Sample", amount.ToString("c",current.NumberFormat), amount.ToString("c", spanish.NumberFormat))
            }; 

            var strings = new List<String>()
            { 
                "management",
                "mandate",
                "mañana",
                "manifold",
                "manual",
                "maximum",
                "polymorphism"
            };



            List<String> sortedCurrent = new List<String>(strings);
            List<String> sortedSpanish = new List<String>(strings);

            sortedCurrent.Sort();

            // string sortedCurrentText =;
            System.Threading.Thread.CurrentThread.CurrentCulture = spanish;
            sortedSpanish.Sort();

            System.Threading.Thread.CurrentThread.CurrentCulture = current;

            items.Add(new CultureInfoData("SortedList", String.Join(" ", sortedCurrent.ToArray()), String.Join(" ", sortedSpanish.ToArray())));

            ListBoxItems.ItemsSource = items;
        } 
    }  
} 