﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.ComponentModel;
using System.Reflection;
using Microsoft.Phone.Tasks;
using Microsoft.Phone.Marketplace;

namespace SAMSMobileCitizenry
{
    public partial class AboutPage : PhoneApplicationPage
    {   
        public AboutPage()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(AboutPage_Loaded);
        }

        void AboutPage_Loaded(object sender, RoutedEventArgs e)
        {
            textBlockVersion.Text = GetAppVersion();
            ToggleBuyVisibility();
        }

        public string GetAppVersion()
        {
            Assembly assembly = Assembly.GetExecutingAssembly();
            var name = new AssemblyName(assembly.FullName);
            return name.Version.ToString();
        }

        public bool IsTrialMode()
        {
            var s = new LicenseInformation();
            #if DEBUG
                        return true;
            #else
                            return s.IsTrial();               
            #endif
        }
        private void ToggleBuyVisibility()
        {
            if (!IsTrialMode())
            {
                buttonBuyApp.Visibility = Visibility.Collapsed;
            }
        }
        private void buttonReviewApp_Click(object sender, RoutedEventArgs e)
        {
            if (Microsoft.Devices.Environment.DeviceType == Microsoft.Devices.DeviceType.Device)
            {
                MarketplaceReviewTask tsk = new MarketplaceReviewTask();
                tsk.Show();
            }
            else
            {
                MessageBox.Show("you're in the emulator, can't do this right now", "emulator", MessageBoxButton.OK);
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if (Microsoft.Devices.Environment.DeviceType == Microsoft.Devices.DeviceType.Device)
            {
                MarketplaceDetailTask tsk = new MarketplaceDetailTask();
                tsk.Show();
            }
            else
            {
                MessageBox.Show("you're in the emulator, can't do this right now", "emulator", MessageBoxButton.OK);
            }
        }

        private void textBlockHomeWebsite_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            WebBrowserTask tsk = new WebBrowserTask();
            tsk.URL = "http://www.devfish.net";
            tsk.Show();
        }

        private void buttonEmailSupport_Click(object sender, RoutedEventArgs e)
        {
            if (Microsoft.Devices.Environment.DeviceType == Microsoft.Devices.DeviceType.Device)
            {
                EmailComposeTask tsk = new EmailComposeTask();
                tsk.Body = Environment.NewLine + Environment.NewLine + Environment.NewLine +
                        "SAMSWP724 Mobile Citizenry v" + GetAppVersion();
                tsk.Subject = "SAMSWP724 Feedback";
                tsk.To = "sample@devfish.net";
                tsk.Show();
            }
            else
            {
                MessageBox.Show("you're in the emulator, can't do this right now", "emulator", MessageBoxButton.OK);
            }            
        }
    }
}