﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Media.Imaging;

namespace SAMSMobileCitizenry
{
    public partial class ThemedImagesPage : PhoneApplicationPage
    {
        static string m_theme = String.Empty;
        public string Theme 
        {   get 
                {
                    if ( m_theme == String.Empty )
                        m_theme = ((Visibility)Application.Current.Resources["PhoneDarkThemeVisibility"] == Visibility.Visible) ? "dark" : "light"; 
                    return m_theme;
                }
        }
     
        public ThemedImagesPage()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(ThemedImagesPage_Loaded);
        }

        void ThemedImagesPage_Loaded(object sender, RoutedEventArgs e)
        {
            textBlockTheme.Text = DetectTheme();
            ThemeImages();
        }

        private string DetectTheme()
        {
            return ((Visibility)Application.Current.Resources["PhoneDarkThemeVisibility"] == Visibility.Visible) ? "dark" : "light";
        }

        private void ThemeImages()
        {
            ThemeImage(imgRest,"appbar.back.rest.png");
            ThemeImage(imgCamera, "appbar.feature.camera.rest.png");
            ThemeImage(imgSettings, "appbar.feature.settings.rest.png");
            ThemeImage(imgVideo, "appbar.feature.video.rest.png");
            ThemeImage(imgShare, "appbar.share.rest.png");
        }
        private void ThemeImage( Image img, string imagelink )
        {
            string newsource = string.Format( @"/images/{0}/{1}",Theme, imagelink);            
            BitmapImage bi = new BitmapImage();
            bi.CreateOptions = BitmapCreateOptions.None;
            bi.UriSource = new Uri(newsource, UriKind.Relative);
            img.Source = bi;
        }
    }
}