﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using System.Diagnostics;
using Microsoft.Phone.Shell;

namespace WindowsPhoneApplication1
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }
        protected override void OnNavigatedFrom(System.Windows.Navigation.NavigationEventArgs e)
        {
            Debug.WriteLine(String.Format("MainPage->OnNavigatedFrom e.Content={0},e.Uri={1}", e.Content, e.Uri));
            if ( e.Content == null )
            {
                Debug.WriteLine("... TOMBSTONING, becoming a ZOMBIE");
                PhoneApplicationService.Current.State[TombStoneHelper.MAINPAGE_TEXTBOX1] = textBox1.Text;
                PhoneApplicationService.Current.State[TombStoneHelper.MAINPAGE_TEXTBOX2] = textBox2.Text;
            }
            base.OnNavigatedFrom(e);
        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            Debug.WriteLine("MainPage->OnNavigatedTo, e.Content=" + e.Content.ToString());

            // if we arrived here via TOMBSTONE
            if (TombStoneHelper.RESURRECTED)
            {
                Debug.WriteLine("... RESURRECTION");
                // Clear our flag
                TombStoneHelper.RESURRECTED = false;

                if (PhoneApplicationService.Current.State.ContainsKey(TombStoneHelper.MAINPAGE_TEXTBOX1))
                {
                    Debug.WriteLine("Hydrating textBox1");
                    textBox1.Text = (String)PhoneApplicationService.Current.State[TombStoneHelper.MAINPAGE_TEXTBOX1];
                }
                if (PhoneApplicationService.Current.State.ContainsKey(TombStoneHelper.MAINPAGE_TEXTBOX2))
                {
                    Debug.WriteLine("Hydrating textBox2");
                    textBox2.Text = (String)PhoneApplicationService.Current.State[TombStoneHelper.MAINPAGE_TEXTBOX2];
                }
            }
            else
            {
                Debug.WriteLine("... normal navigation, no resurrection");
            }
            base.OnNavigatedTo(e);
        }
    }
}