﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Devices.Sensors;

namespace PhoneApp1
{
    public partial class MainPage : PhoneApplicationPage
    {
        private Accelerometer accelerometer;

        // Constructor
        public MainPage()
        {
            InitializeComponent();
            if (Accelerometer.IsSupported)
            {
                accelerometer = new Accelerometer();
                accelerometer.CurrentValueChanged += new EventHandler<SensorReadingEventArgs<AccelerometerReading>>(accelerometer_CurrentValueChanged);
                accelerometer.Start();
            }
        }

        private void accelerometer_CurrentValueChanged(object sender, SensorReadingEventArgs<AccelerometerReading> e)
        {
            Dispatcher.BeginInvoke(() =>
                {
                    this.xValue.Text = e.SensorReading.Acceleration.X.ToString();
                    this.yValue.Text = e.SensorReading.Acceleration.Y.ToString();
                    this.zValue.Text = e.SensorReading.Acceleration.Z.ToString();
                });
        }
    }
}