﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Devices.Sensors;

namespace PhoneApp1
{
    public partial class MainPage : PhoneApplicationPage
    {
        private Compass compass;

        // Constructor
        public MainPage()
        {
            InitializeComponent();
            if (Compass.IsSupported)
            {
                compass = new Compass();
                compass.CurrentValueChanged += new EventHandler<SensorReadingEventArgs<CompassReading>>(compass_CurrentValueChanged);
                compass.Start();
            }
        }

        private void compass_CurrentValueChanged(object sender, SensorReadingEventArgs<CompassReading> e)
        {
            Dispatcher.BeginInvoke(() =>
                {
                    this.trueHeading.Text = e.SensorReading.TrueHeading.ToString();
                    this.magneticHeading.Text = e.SensorReading.MagneticHeading.ToString();
                    this.headingAccuracy.Text = e.SensorReading.HeadingAccuracy.ToString();
                    this.magnetometerReading.Text = e.SensorReading.MagnetometerReading.ToString();
                });
        }
    }
}