﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Devices.Sensors;

namespace PhoneApp1
{
    public partial class MainPage : PhoneApplicationPage
    {
        private Gyroscope gyro;

        // Constructor
        public MainPage()
        {
            InitializeComponent();
            if (Gyroscope.IsSupported)
            {
                gyro = new Gyroscope();
                gyro.CurrentValueChanged += new EventHandler<SensorReadingEventArgs<GyroscopeReading>>(gyro_CurrentValueChanged);
                gyro.Start();
            }
        }

        private void gyro_CurrentValueChanged(object sender, SensorReadingEventArgs<GyroscopeReading> e)
        {
            Dispatcher.BeginInvoke(() =>
                {
                    this.xValue.Text = e.SensorReading.RotationRate.X.ToString();
                    this.yValue.Text = e.SensorReading.RotationRate.Y.ToString();
                    this.zValue.Text = e.SensorReading.RotationRate.Z.ToString();
                });
        }
    }
}