﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Devices.Sensors;

namespace PhoneApp1
{
    public partial class MainPage : PhoneApplicationPage
    {
        private Motion motion;

        // Constructor
        public MainPage()
        {
            InitializeComponent();

            if (Motion.IsSupported)
            {
                motion = new Motion();
                motion.CurrentValueChanged += new EventHandler<SensorReadingEventArgs<MotionReading>>(motion_CurrentValueChanged);
                motion.Start();
            }
        }

        private void motion_CurrentValueChanged(object sender, SensorReadingEventArgs<MotionReading> e)
        {
            Dispatcher.BeginInvoke(() =>
                {
                    this.attitude.Text = String.Format("{0}, {1}, {2}, {3}", e.SensorReading.Attitude.Pitch, e.SensorReading.Attitude.Roll, e.SensorReading.Attitude.Yaw, e.SensorReading.Attitude.Quaternion);
                    this.deviceAcceleration.Text = e.SensorReading.DeviceAcceleration.ToString();
                    this.deviceRotation.Text = e.SensorReading.DeviceRotationRate.ToString();
                    this.gravity.Text = e.SensorReading.Gravity.ToString();
                });
        }
    }
}